#include <iostream>
#include <stdio.h>
#include <vector>

using namespace std;

int visine[100000];
int levi[100000];
int desni[100000];
int charges[100000];

void sortByLeft(int n){
    for(int i=0;i<n-1;++i){
        for(int j=i+1;j<n;++j){
            if(levi[j]<levi[i]){
                swap(levi[i],levi[j]);
                swap(desni[i],desni[j]);
                swap(charges[i],charges[j]);
            }
        }
    }
}

class prq{
    private:
        vector<int> pokazivaci;
    public:
//        prq();
        void insert(int);
        int chargesAtFront();
        void changeFront(int);
        void removeFront();


};

void prq::insert(int a){
    if(pokazivaci.empty()){
        pokazivaci.push_back(a);
    }
    else{
        int limitL=pokazivaci.size()-1;
        int limitD=0;
        int mid;
        while(limitL!=limitD){
            mid=(limitL+limitD)/2;
            if(desni[a]>desni[mid]){
                limitL=mid+1;
            }
            else if(desni[a]<=desni[mid]){
                limitD=mid-1;
            }
        }

        pokazivaci.insert(pokazivaci.begin()+limitD+1, a);
    }
}

int prq::chargesAtFront(){
    if(pokazivaci.empty())
        return -1;
    return charges[pokazivaci.at(0)];
}
void prq::removeFront(){
    pokazivaci.erase(pokazivaci.begin());
}

void prq::changeFront(int a){
    charges[*pokazivaci.begin()]=a;
}

int main()
{
    int t;
    int zgrada,dece;

    cin>>t;
    for(int test=0;test<t;++test){
        scanf("%i %i", &zgrada, &dece);
        for(int i=0;i<zgrada;++i)
            scanf("%i",&visine[i]);
        for(int i=0;i<dece;++i)
            scanf("%i",&levi[i]);
        for(int i=0;i<dece;++i)
            scanf("%i",&desni[i]);
        for(int i=0;i<dece;++i)
            scanf("%i",&charges[i]);

        sortByLeft(dece);
        prq glavni;
        int pokNaDecu=0;
        if(levi[pokNaDecu]!=1){
            printf("NE\n");
        }
        else{
            for(int i=0;i<zgrada;++i){
                if(levi[pokNaDecu]-1==i){
                    glavni.insert(pokNaDecu++);
                };

                if(glavni.chargesAtFront()>visine[i]){
                    visine[i]=0;
                    glavni.changeFront(glavni.chargesAtFront()-visine[i]);
                }
                else{
                    while(glavni.chargesAtFront()<visine[i]){
                        if(glavni.chargesAtFront()==-1){
                            printf("NE\n");
                            break;
                        }
                        visine[i]=visine[i]-glavni.chargesAtFront();
                        glavni.removeFront();
                    }

                    visine[i]=0;
                    glavni.changeFront(glavni.chargesAtFront()-visine[i]);
                }

            }
        }
        printf("DA\n");

    }



    return 0;
}


/*
2
3 2
1 4 2
1 2
3 3
3 4



*/