#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    string S;
    vector<int> Q;
    int index = 0;
    for(int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if(t == 1) {
            char c;
            cin >> c;
            S.push_back(c);
            index++;
        } else {
            Q.push_back(index);
        }
    }
    int Ssize = S.size();
    vector<int> diffV(Ssize + 1, 0);
    int diffVsize = diffV.size();
    int Qsize = Q.size();
    for(int i = 0; i < Qsize; i++) {
        diffV[0] += Q[i]/2;
        diffV[Q[i]/2] -= Q[i];
        diffV[Q[i]] += Q[i]/2;
    }
    for(int i = 1; i < diffVsize; i++) {
        diffV[i] += diffV[i-1];
    }
    for(int i = 0; i < diffVsize; i++) {
        diffV[i] += i + 1;
    }
    vector<char> sol(Ssize);
    for(int i = 0; i < diffVsize; i++) {
        if(diffV[i] > 0 && diffV[i] > Ssize) diffV[i] -= Ssize;
        else if(diffV[i] <= 0) diffV[i] += Ssize;
        if(i < diffVsize-1) sol[diffV[i]-1] = S[i];
    }
    for(int i = 0; i < Ssize; i++) cout << sol[i];
}
/*9
1 a
1 b
2
1 a
1 m
2
1 a
1 d
2*/

/*
4
1 a
1 b
2
1 c
*/