#include <iostream>
#include <vector>
#include <set>

using namespace std;

const int INF = 100000; // TODO

int main()
{
    /*int n;

    cin >> n;

    int akcija;
    char slovo;

    for (int i = 0; i < n; i++) {
        cin >> akcija;

        if (akcija == 1) {
            cin >> slovo;
        } else {

        }


    }*/

    int n, m;

    cin >> n >> m;

    vector<int> xA(n), xB(m);

    set<int> sa, sb;

    for (int i = 0; i < n; i++) {
        cin >> xA[i];
        sa.insert(xA[i]);
    }

    int x;

    int indeks = 0;

    for (int i = 0; i < m; i++) {
        cin >> x;

        if (sa.find(x) != sa.end()) {
            xB[indeks++] = x;
            sb.insert(x);
        }
    }

    for (set<int>::iterator it = sa.begin(); it != sa.end();) {
        int x = *it;

        if (sb.find(x) == sb.end()) {
            sa.erase(it++);
        } else {
            ++it;
        }

    }



    vector<int> A;

    for (int i = 0; i < n; i++) {
        if (sa.find(xA[i]) != sa.end()) {
            A.push_back(xA[i]);
        }
    }

    const int SIZE = indeks;

    vector<int> vi(SIZE + 1, -INF);
    vi[0] = 0;
    vector<vector<int> > DP(SIZE + 1, vi);
    DP[0] = vector<int>(SIZE + 1, 0);

    for (int i = 1; i <= SIZE; i++) {
        for (int j = 1; j <= SIZE; j++) {
            if (A[i - 1] == xB[j - 1]) {
                DP[i][j] = max(max(DP[i - 1][j], DP[i][j - 1]), DP[i - 1][j - 1] + 1);
            } else {
                DP[i][j] = max(DP[i - 1][j], DP[i][j - 1]);
            }
        }
    }

    cout << (n + m - 2 * DP[SIZE][SIZE]) << endl;

    return 0;
}