#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;
#define pb push_back
#define mp make_pair
const int N=100050;
int a[N],id[N],b[N],dep[N],par[N],val[N];
vector<int> E[N],ids[N];
void DFS(int u, int p, int d)
{
    dep[u]=0;
    par[u]=p;
    for(int i=0;i<E[u].size();i++)
    {
        int v=E[u][i];
        if(v!=p) DFS(v,u,d+1),dep[u]=max(dep[u],dep[v]+1);
    }
}
void run()
{
    int n,m,i,j,u,v;
    scanf("%i",&n);
    for(i=1;i<=n;i++) scanf("%i",&a[i]);
    scanf("%i",&m);
    for(i=1;i<=m;i++) E[i].clear(),id[i]=i;
    for(i=1;i<m;i++) scanf("%i %i",&u,&v),E[u].pb(v),E[v].pb(u);
    DFS(1,0,1);
    if(m>7 || n>5){ printf("DA\n");return;}
    while(a[n]==n) n--;
    if(m<n){ printf("NE\n");return;}
    //for(i=1;i<=m;i++) printf("%i ",dep[i]);printf("\n");
    do
    {
        bool ok=1;
        for(i=1;i<=m;i++) for(j=i+1;j<=m;j++) if(dep[id[j]]<dep[id[i]]) ok=0;
        if(!ok) continue;
        //for(i=1;i<=m;i++) printf("%i ",id[i]);printf("\n");
        for(i=1;i<=m;i++) val[i]=0;
        bool done=1;
        for(i=1;i<=n;i++)
        {
            if(val[id[i]]>a[i]){ done=0;break;}
            val[par[id[i]]]=max(val[par[id[i]]],a[i]);
        }
        if(done){ printf("DA\n");return;}
    }while(next_permutation(id+1,id+1+m));
    printf("NE\n");
}
int main()
{
    int t;
    scanf("%i",&t);
    while(t--) run();
    return 0;
}