#include <iostream>
#include <vector>
using namespace std;

/*
2
3
3 1 2
4
1 2
2 3
1 4
3
3 2 1
2
2 1
*/

vector<int> m(8);
vector<int> n(8);
vector<vector<vector<int> > > stablo(8, vector<vector<int> > (100010));
vector<vector<int> > perm(8, vector<int> (100010));
vector<vector<int> > permidx(8, vector<int> (100010));

vector<vector<int> > broj_potomaka(8, vector<int> (100010));
vector<vector<bool> > mark_cvor(8, vector<bool> (100010));

int dfs(int index, int cvor)
{
    mark_cvor[index][cvor]=true;

    int sum=0;
    for (int j=0; j<stablo[index][cvor].size(); j++)
    {
        if (!mark_cvor[index][stablo[index][cvor][j]]) sum+=1+dfs(index, stablo[index][cvor][j]);
    }

    //cout <<cvor <<endl;

    broj_potomaka[index][cvor]=sum;
    return sum;
}

bool dfs2(int index, int cvor, int clan, int cnt)
{
    mark_cvor[index][cvor]=true;



    //dal mogu da stavim clan ovde
    if (m[index]-cnt-broj_potomaka[index][cvor]>=permidx[index][clan])
    {
        //cout <<" stavio sam " <<clan <<" u " <<cvor <<endl;
        if (clan==0)
        {
            return true;
        }
        else
        for (int j=0; j<stablo[index][cvor].size(); j++)
        {
            if (!mark_cvor[index][stablo[index][cvor][j]])
            {
                return dfs2(index, stablo[index][cvor][j], clan-1, cnt+1);
            }
        }
        if (stablo[index][cvor].size()==0) return false;

    }
    else
    {
        //cout <<" nisam stavio " <<clan <<" u " <<cvor <<endl;
        for (int j=0; j<stablo[index][cvor].size(); j++)
        {
            if (!mark_cvor[index][stablo[index][cvor][j]])
            {
                return dfs2(index, stablo[index][cvor][j], clan, cnt+1);
            }
        }
        if (stablo[index][cvor].size()==0) return false;
    }
}

int main()
{
    cin.sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >>t;

    int u,v;
    for (int i=0; i<t; i++)
    {
        cin >>n[i];
        for (int j=0; j<n[i]; j++) cin >>perm[i][j];
        cin >>m[i];

        for (int j=0; j<m[i]-1; j++)
        {
            cin >>u >>v;
            stablo[i][u-1].push_back(v-1);
            stablo[i][v-1].push_back(u-1);
        }
    }

    /*
    for (int i=0; i<t; i++)
    {
        for (int j=0; j<m[i]; j++)
        {
            cout <<j <<"  ";
            for (int k=0; k<stablo[i][j].size(); k++)
            {
                cout <<stablo[i][j][k] <<" ";
            }
            cout <<endl;
        }
    }
    */


    for (int i=0; i<t; i++)
    {
        for (int j=0; j<m[i]; j++)
        {
            broj_potomaka[i][j]=0;
            mark_cvor[i][j]=false;
        }
    }

    for (int i=0; i<t; i++)
    {
        broj_potomaka[i][0] = dfs(i,0);
    }

    /*
    for (int i=0; i<t; i++)
    {
        for (int j=0; j<m[i]; j++) cout <<broj_potomaka[i][j] <<" ";
        cout <<endl;
    }
    */

    for (int i=0; i<t; i++)
    {
        for (int j=0; j<n[i]; j++)
            permidx[i][perm[i][j]-1]=j;
    }

    /*
    for (int i=0; i<t; i++)
    {
        for (int j=0; j<n[i]; j++)
            cout <<permidx[i][j] <<endl;
    }
    */



    for (int i=0; i<t; i++)
    {
        for (int j=0; j<m[i]; j++)
        {
            mark_cvor[i][j]=false;
        }
    }

    vector<bool> odgovori(t);
    for (int i=0; i<t; i++)
    {
        odgovori[i] = dfs2(i, 0, n[i]-1, 0);
    }

    for (int i=0; i<t; i++)
    {
        if (odgovori[i]) cout <<"DA" <<endl;
        else cout <<"NE" <<endl;
    }


    return 0;
}