#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct dete
{
    int l, r, k;
};

vector<vector<int> > grad(8, vector<int> (100010));
vector<vector<int> > suma(8, vector<int> (100010));
vector<vector<dete> > deca(8, vector<dete> (100010));
vector<vector<int> > pozicija(8, vector<int> (100010));
vector<int> n(8);
vector<int> m(8);

bool comp (dete a, dete b)
{
    if (a.r>b.r) return true;
    else if (a.r<b.r) return false;
    else
    {
        return (a.l>b.l);
    }
}

int main()
{
    int t;
    cin >>t;

    for (int i=0; i<t; i++)
    {
        cin >>n[i] >>m[i];

        for (int j=0; j<n[i]; j++) cin >>grad[i][j];
        for (int j=0; j<m[i]; j++) cin >>deca[i][j].l;
        for (int j=0; j<m[i]; j++) cin >>deca[i][j].r;
        for (int j=0; j<m[i]; j++) cin >>deca[i][j].k;
    }

    for (int i=0; i<t; i++)
    {
        suma[i][0]=grad[i][0];
        for (int j=0; j<=grad[i][0]; j++) pozicija[i][j]=0;
        for (int j=1; j<n[i]; j++)
        {
            suma[i][j]=suma[i][j-1]+grad[i][j];
            for (int k=suma[i][j-1]+1; k<=suma[i][j]; k++) pozicija[i][k]=j;
        }

    }

    for (int i=0; i<t; i++)
    {
        sort(deca[i].begin(),deca[i].begin()+m[i],comp);

        //for (int j=0; j<m[i]; j++) cout  <<deca[i][j].r <<" " <<deca[i][j].l <<" " <<deca[i][j].k <<endl;
        //cout <<endl;
    }

/*
    for (int i=0; i<t; i++)
    {
        //suma[i][0]=0;
        for (int j=0; j<n[i]; j++) cout <<suma[i][j] <<" ";
        cout <<endl;
        for (int j=0; j<=suma[i][n[i]-1]; j++) cout <<pozicija[i][j] <<" ";
        cout <<endl;
    }
*/
    bool k;
    for (int i=0; i<t; i++)
    {
        k=false;
        int ostalo = suma[i][n[i]-1];//+grad[i][n[i]-1];
        int ostalo_ind = n[i]-1;

        for (int j=0; j<deca[i].size(); j++)
        {
            if (ostalo==0)
            {
                k=true;
                cout <<"DA" <<endl;
                break;
            }

            if (deca[i][j].r-1<ostalo_ind)
            {
                k=true;
                cout <<"NE" <<endl;
                break;
            }
            else if (deca[i][j].l-1<=ostalo_ind)
            {
                ostalo = max(ostalo - deca[i][j].k, suma[i][deca[i][j].l-1] - grad[i][deca[i][j].l-1]);
                ostalo_ind=pozicija[i][ostalo];
                //cout <<ostalo <<" " <<ostalo_ind <<endl;
            }

        }

        if (!k) cout <<"NE" <<endl;
    }

    /*
2
3 2
1 4 2
1 2
3 3
3 4
1 1
10
1
1
6
    */



    return 0;
}