#include <stdio.h>
#include <utility>
#include <algorithm>

using namespace std;

struct triple
{
    int first;
    int second;
    int third;
};

int cmp(triple t1, triple t2)
{
    if(t1.first<t2.first)
        return 1;
    if(t1.first==t2.first && t1.second<t2.second)
        return 1;
    return 0;
}

int t, n, m, a[100001];

triple c[100001];

bool calc()
{
    for(int i=1, j=1; i<=n, j<=m;)
    {
        if(i<c[j].first && a[i]!=0)
            return false;
        if(i>c[j].second)
        {
            j++;
            continue;
        }
        if(a[i]>c[j].third)
        {
            a[i]-=c[j].third;
            ++j;
        }
        if(a[i]==c[j].third)
        {
            a[i]=0;
            ++i;
            ++j;
        }
        if(a[i]<c[j].third)
        {
            c[j].third-=a[i];
            a[i]=0;
            ++i;
        }
    }
    if(a[n]==0)
        return 1;
    return 0;
}

int main()
{
    scanf("%d", &t);
    for(int i=0; i<t; ++i)
    {
        scanf("%d%d", &n, &m);
        for(int j=1; j<=n; ++j)
            scanf("%d", &a[j]);
        for(int j=1; j<=m; ++j)
            scanf("%d", &c[j].first);
        for(int j=1; j<=m; ++j)
            scanf("%d", &c[j].second);
        for(int j=1; j<=m; ++j)
            scanf("%d", &c[j].third);
        sort(c, c+m, cmp);
        bool r=calc();
        if(r)
            printf("DA\n");
        else
            printf("NE\n");
    }
}