#include <iostream>
#include <cstdlib>

using namespace std;

int n, m;
int a[200001] = {}, b[200001] = {};
int **mat;

static inline int max3(int a, int b, int c)
{
    if (a > b)
        if (a > c)
            return a;
        else
            return c;
    else
        if (b > c)
            return b;
        else
            return c;
}

int main()
{
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0); cerr.tie(0);
    cin >> n >> m;
    mat = (int**)(malloc((m + 1) * sizeof (int*)));
    for (int i = 0; i <= m; i++)
        mat[i] = (int*)(malloc((n + 1) * sizeof (int)));
    for (int i = 0; i <= n; i++)
        mat[0][i] = 0;
    for (int i = 0; i <= m; i++)
        mat[i][0] = 0;
    for (int i = 1; i <= n; i++)
        cin >> a[i];
    for (int i = 1; i <= m; i++)
        cin >> b[i];
    for (int i = 1; i <= m; i++)
        for (int j = 1; j <= n; j++)
        {
            mat[i][j] = max3(mat[i-1][j], mat[i][j-1], mat[i-1][j-1]);
            if (a[j] == b[i]) mat[i][j]++;
        }
    cout << n + m - mat[m][n] * 2 << endl;
    return 0;
}