#include <bits/stdc++.h>
using namespace std;

int t;
int n;
int p[100005];
int m;
int u,v;
vector<int> adj[100005];
vector<int> leaf;
bool vis[100005];
int par[100005];
int subtree[100005];

void dfs(int cur,int prev)
{
    vis[cur]=true;
    par[cur]=prev;
    if(adj[cur].size()==1)
        leaf.push_back(cur);
    for(int i=0; i<adj[cur].size(); i++)
        if(!vis[adj[cur][i]])
            dfs(adj[cur][i],cur);
}

void dfs2(int cur)
{
    while(cur!=1)
    {
        subtree[par[cur]]+=subtree[cur];
        cur=par[cur];
    }
}

int main()
{
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d",&n);
        for(int i=1; i<=n; i++)
            scanf("%d",&p[i]);
        scanf("%d",&m);
        for(int i=0; i<m-1; i++)
        {
            scanf("%d%d",&u,&v);
            adj[u].push_back(v);
            adj[v].push_back(u);
        }
        dfs(1,0);
        for(int i=1; i<=m; i++)
            subtree[i]=1;
        for(int i=0; i<leaf.size(); i++)
            dfs2(leaf[i]);
        while(n>0)
        {
            if(p[n]==n) n--;
            else break;
        }
        bool res=false;
        if(n==0)
            res=true;
        if(subtree[1]>n && adj[1].size()>=2)
            res=true;
        for(int i=1; i<=m; i++)
            if(subtree[i]>n && adj[i].size()>2)
                res=true;
        if(res) printf("DA\n");
        else printf("NE\n");

        for(int i=1; i<=m; i++)
        {
            adj[i].clear();
            vis[i]=false;
            par[i]=0;
        }
        leaf.clear();

    }
    return 0;
}