#include <bits/stdc++.h>
using namespace std;

struct object{
    int br1, br2;

    bool operator < (const object& other)const{
        if(br1 == other.br1){
            return br2 < other.br2;
        }
        return br1 < other.br1;
    }
};

int n, m;
int nizn[200010], nizm[200010];
map<object, int> dp;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie();

    cin >> n >> m;
    for(int i = 1; i <= n; ++i){
        cin >> nizn[i];
    }
    for(int i = 1; i <= m; ++i){
        cin >> nizm[i];
    }

    for(int i = 1; i <= n; ++i){
        for(int j = 1; j <= m; ++j){
            object x = {i, j};
            object x1 = {i-1, j-1};
            object y1 = {i, j-1};
            object y2 = {i-1, j};
            if(nizn[i] == nizm[j]){
                dp[x] = dp[x1] + 1;
            }
            else{
                dp[x] = max(dp[y1], dp[y2]);
            }
        }
    }

    object res = {n, m};
    int resenje = n + m - 2*dp[res];
    cout << resenje << "\n";
}