#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

vector<pair<int, int> > DP;
string a, b;

int f(int x, int cmp){
    for(int i = x - 1; i >= 0; i--)
        if(DP[i].second < cmp)
            return i;
    return -1;
}

int main(){

    int n, m;
    cin >> n >> m;

    vector<int> a(n), b(m);

    for(int i = 0; i < n; i++)
        cin >> a[i];

    for(int i = 0; i < m; i++)
        cin >> b[i];

    pair<int, int> pii(0, 0);
    DP.resize(n, pii);

    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
            if(a[i] == b[j]){
                int tmp = f(i, j);
                if(tmp != -1){
                    if(DP[i].first < DP[tmp].first + 1){
                        DP[i].first = DP[tmp].first + 1;
                        DP[i].second = j;
                    }
                }else {
                    DP[i].first = 1;
                    DP[i].second = j;
                }
            }

    cout << n + m - (2 * DP[n - 1].first) << endl;

    return 0;
}

/*

4 6
2 1 3 4
5 2 3 4 1 6

*/