#include <bits/stdc++.h>
using namespace std;
#define maxN 100000
#define max(a, b) ((a)>(b) ? (a) : (b))
#define min(a, b) ((a)>(b) ? (b) : (a))

int n, m;
int a[maxN], p[maxN];
vector<int> g[maxN];
int s[maxN + 1];
int seg[maxN + 1];
set<pair<int, int> > st;

int dfs(int cur, int pr = -1, int depth = 0) {
	int ret = 1;
	for (int i = 0; i < g[cur].size(); i++)
		if (g[cur][i] != pr) {
			ret += dfs(g[cur][i], cur, depth + 1);
		}
	s[depth] = min(s[depth], ret);
	return ret;
}

/*
2

3
3 1 2
4
1 2
2 3
1 4

3
3 2 1
2
2 1

*/

void upd(int x) {
	x++;
	while (x <= n)
		seg[x]++, x += x & -x;
}

int sum(int x) {
	x++;
	int ret = 0;
	while (x > 0)
		ret += seg[x], x -= x & -x;
	return ret;
}

int waste(int x) {
	int ret = m;
	int i = (*(st.lower_bound(make_pair(x, 0)))).second;
	ret = min(ret, i + max(0, s[i] - 1 + x));
	i = (*(st.upper_bound(make_pair(x, 0)))).second;
	ret = min(ret, i + max(0, s[i] - 1 + x));
	/*
	for (int i = 0; i <= m; i++)
		ret = min(ret, i + max(0, s[i] - 1 + x));
	*/
	return ret;
}

int main() {
	int tc;
	scanf("%d", &tc);
	while (tc--) {
		bool sol = true;
		for (int i = 0; i < m; i++)
			g[i].clear();
		for (int i = 0; i <= n; i++)
			seg[i] = 0;
		scanf("%d", &n);
		for (int i = 0; i < n; i++) {
			scanf("%d", &a[i]);
			a[i]--;
			p[a[i]] = i;
		}
		scanf("%d", &m);
		for (int i = 0; i <= m; i++)
			s[i] = m + 1;
		int u, v;
		for (int i = 1; i < m; i++) {
			scanf("%d %d", &u, &v);
			g[--u].push_back(--v);
			g[v].push_back(u);
		}
		dfs(0);
		for (int i = 0; i <= m; i++)
			st.insert(make_pair(s[i], i));
		bool qed = true;
		for (int i = 0; i < n; i++) {
			int pos = p[i];
			int l = sum(pos);
			if (l < a[i] && m - waste(l) < a[i] + 1)
				qed = false;
			upd(pos);
		}
		printf(qed ? "DA\n" : "NE\n");
	}
	return 0;
}