#include <bits/stdc++.h>
using namespace std;
#define maxN 100000
#define max(a, b) ((a)>(b) ? (a) : (b))
#define min(a, b) ((a)>(b) ? (b) : (a))

int n, m;
int a[maxN], p[maxN];
vector<int> g[maxN];
int s[maxN + 1];
int seg[maxN + 1];
int d;

int dfs(int cur, int pr = -1, int depth = 0) {
    d = max(d, depth);
	int ret = 1;
	for (int i = 0; i < g[cur].size(); i++)
		if (g[cur][i] != pr) {
			ret += dfs(g[cur][i], cur, depth + 1);
		}
	s[depth] = min(s[depth], ret);
	return ret;
}

/*
2

3
3 1 2
4
1 2
2 3
1 4

3
3 2 1
2
2 1

*/

void upd(int x) {
	x++;
	while (x <= n)
		seg[x]++, x += x & -x;
}

int sum(int x) {
	x++;
	int ret = 0;
	while (x > 0)
		ret += seg[x], x -= x & -x;
	return ret;
}

int f(int x, int id) {
    return id + max(0, s[id] - 1 + x);
}

int waste(int x) {
    int h = d;
    int l = 0;
    int md = (l + h) / 2;
    while (l < h) {
        md = (l + h) / 2;
        if (s[md] < x)
            l = md + 1;
        else
            h = md - 1;
    }
    int ret = m;
    for (int i = md - 10; i < md + 10; i++)
        if (i >= 0 && i <= d)
            ret = min(ret, f(x, i));
	return ret;
}

int main() {
	int tc;
	scanf("%d", &tc);
	while (tc--) {
        d = -1;
		for (int i = 0; i < m; i++)
			g[i].clear();
		for (int i = 0; i <= n; i++)
			seg[i] = 0;
		scanf("%d", &n);
		for (int i = 0; i < n; i++) {
			scanf("%d", &a[i]);
			a[i]--;
			p[a[i]] = i;
		}
		scanf("%d", &m);
		for (int i = 0; i <= m; i++)
			s[i] = m + 1;
		int u, v;
		for (int i = 1; i < m; i++) {
			scanf("%d %d", &u, &v);
			g[--u].push_back(--v);
			g[v].push_back(u);
		}
		dfs(0);
		for (int i = 1; i < m; i++)
            s[i] = min(s[i-1], s[i]);
		bool qed = true;
		for (int i = 0; i < n; i++) {
			int pos = p[i];
			int l = sum(pos);
			if (l < i && m - waste(l) < i + 1)
				qed = false;
			upd(pos);
		}
		printf(qed ? "DA\n" : "NE\n");
	}
	return 0;
}