#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

int par[100005], b[100005], a[100005], fin[100005], br[100005], c[100005], n, m, t, u, v, gran;
bool taken[100005], done;
vector<int> g[100005];

int cnt(int x, int p) {
    if (g[x].size() == 1) return 1;
    return 1+cnt(g[x][0] == p ? g[x][1] : g[x][0], x);
}

void dfs(int x, int p) {
    par[x] = p;
    for (int i = 0; i < g[x].size(); i++)
        if (g[x][i] != p) dfs(g[x][i], x);
}

bool checkrek(int x, int val, int ind) {
    if (b[x] != 0) {
        if (a[b[x]] > val) return false;
        if (b[x] > ind) return false;
    }
    int res = true;
    for (int i = 0; i < g[x].size(); i++) {
        if (g[x][i] != par[x]) res &= checkrek(g[x][i], b[x] != 0 ? a[b[x]] : val, b[x] != 0 ? b[x] : ind);
    }
    return res;
}

bool check() {
    int root;
    for (int i = 1; i <= gran; i++)
        if (!taken[i]) return false;
    for (int i = 1; i <= m; i++)
        if (par[i] == 0) root = i;
    return checkrek(root, 1e9, 1e9);
}

void bt(int x) {
    if (x > m) {
        if (check()) {
            done = true;
            for (int i = 1; i <= m; i++) cerr << par[i] << " ";
            cerr << endl;
            for (int i = 1; i <= m; i++) cerr << b[i] << " ";
            cerr << endl;
            return;
        }
    } else {
        for (int i = 0; i <= gran; i++) {
            if (i == 0 || !taken[i]) {
                b[x] = i;
                taken[i] = true;
                bt(x+1);
                taken[i] = false;
                if (done) return;
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> t;
    while (t--) {
        done = false;
        cin >> n;
        gran = 0;
        for (int i = 1; i <= n; i++) cin >> a[i];
        for (int i = n; i >= 1; i--) {
            if (a[i] != i) {
                gran = i;
                break;
            }
        }
        cerr << "GRAN " << gran << endl;
        cin >> m;
        for (int i = 0; i <= m; i++) g[i].clear();
        for (int i = 0; i < m-1; i++) {
            cin >> u >> v;
            g[u].push_back(v);
            g[v].push_back(u);
        }
        dfs(1, 0);

        if (n <= 5 && m <= 7) {
            bt(1);
            if (done) {
                cout << "DA\n";
            }
            if (!done) cout << "NE\n";
        } else {
            for (int i = 0; i <= n; i++) fin[i] = br[i] = c[i] = 0;
            int tr = 0;
            set<int> s;
            for (int i = 1; i <= n; i++) {
                auto it = lower_bound(s.begin(), s.end(), a[i]);
                if (s.empty() || it == s.begin()) fin[a[i]] = tr, br[tr++]++, s.insert(a[i]);
                else {
                    it = prev(it);
                    br[fin[*it]]++;
                    fin[a[i]] = fin[*it];
                    s.erase(it);
                    s.insert(a[i]);
                }
            }
            for (int i = 0; i < tr; i++) cerr << br[i] << " ";
            cerr << endl;
            int w = 0;
            for (int i = 0; i < g[1].size(); i++) {
                c[w++] = cnt(g[1][i], 1);
            }
            for (int i = 0; i < w; i++) cerr << c[i] << " ";
            cerr << endl;
            sort(c, c+w);
            sort(br, br+tr);
            int ind = 0;
            for (int i = 0; i < tr; i++) {
                while (br[i] > 0 && ind < w) br[i]-=c[ind++];
            }
            if (ind > w && br[tr-1] > 0) cout << "NE\n";
            else cout << "DA\n";
        }
    }
    return 0;
}

/*

2
8
5 3 4 2 7 8 1 6
9
1 2
1 3
2 4
2 5
2 6
3 7
7 8
7 9
8
7 8 2 3 5 6 1 4
9
1 2
1 3
2 4
2 5
2 6
3 7
7 8
7 9
8
6 1 8 7 2 4 3 5
9
1 2
1 3
2 4
2 5
2 6
3 7
7 8
7 9
8
4 1 6 5 3 2 8 7
9
1 2
1 3
2 4
2 5
2 6
3 7
7 8
7 9

1
6
3 1 2 5 4 6
10
1 2
2 3
3 4
1 5
5 6
6 7
7 8
8 9
1 10

*/