#include <iostream>
#include <stdio.h>
#include <vector>

using namespace std;

int visine[100000];
int levi[100000];
int desni[100000];
int charges[100000];

void sortByLeft(int n){
    for(int i=0;i<n-1;++i){
        for(int j=i+1;j<n;++j){
            if(levi[j]<levi[i]){
                swap(levi[i],levi[j]);
                swap(desni[i],desni[j]);
                swap(charges[i],charges[j]);
            }
        }
    }
}

class prq{
    private:
        vector<int> pokazivaci;
    public:
//        prq();
        void insert(int);
        int chargesAtFront();
        void changeFront(int);
        void removeFront();
        int front();


};
int prq::front(){
    return pokazivaci[0];
}

void prq::insert(int a){
    if(pokazivaci.empty()){
        pokazivaci.push_back(a);
    }
    else{
        int limitL=0;
        int limitD=pokazivaci.size()-1;
        int mid;
        while(limitL<limitD){
            mid=(limitL+limitD)/2;
            if(desni[a]>desni[pokazivaci[mid]]){
                limitL=mid+1;
            }
            else if(desni[a]<=desni[pokazivaci[mid]]){
                limitD=mid;
            }
        }
        if(desni[a]<=desni[pokazivaci[limitL]])
            pokazivaci.insert(pokazivaci.begin()+limitL, a);
        else
            pokazivaci.insert(pokazivaci.begin()+limitL+1, a);


    }
}

int prq::chargesAtFront(){
    if(pokazivaci.empty())
        return -1;
    return charges[pokazivaci[0]];
}
void prq::removeFront(){
    pokazivaci.erase(pokazivaci.begin());
}

void prq::changeFront(int a){
    charges[pokazivaci[0]]=a;
}

int main()
{
    int t;
    int zgrada,dece;

    cin>>t;
    for(int test=0;test<t;++test){
        scanf("%i %i", &zgrada, &dece);
        for(int i=1;i<=zgrada;++i)
            scanf("%i",&visine[i]);
        for(int i=1;i<=dece;++i)
            scanf("%i",&levi[i]);
        for(int i=1;i<=dece;++i)
            scanf("%i",&desni[i]);
        for(int i=1;i<=dece;++i)
            scanf("%i",&charges[i]);

        sortByLeft(dece);
        prq glavni;
        int pokazivacNaDecu=1;
        int tmp;
        bool moze=true;

        for(int i=1;i<=zgrada;++i){
            while(levi[pokazivacNaDecu]==i){
                glavni.insert(pokazivacNaDecu++);
            }
            if(glavni.chargesAtFront()==-1){
                moze=false;
                break;
            }
            while(visine[i]!=0){
                tmp=min(glavni.chargesAtFront(),visine[i]);
                charges[glavni.front()]-=tmp;
                visine[i]-=tmp;
                if(charges[glavni.front()]==0){
                    glavni.removeFront();
                }
                if(glavni.chargesAtFront()==-1){
                    break;
                }
            }
        }
        if(moze)
            printf("DA\n");
        else
            printf("NE\n");
    }



    return 0;
}


/*
1
7 4
6 8 4 3 2 9 5
1 2 6 6
3 5 7 7
11 12 7 7




*/