#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> v1(n), v2(m);
    for(int i = 0; i < n; i++) {
        cin >> v1[i];
    }
    for(int i = 0; i < m; i++) {
        cin >> v2[i];
    }
    vector<vector<int> > lcs(n+1, vector<int>(m+1));
    for(int i = 0; i <= n; i++) {
        for(int j = 0; j <= m; j++) {
            if(i == 0 || j == 0) {
                lcs[i][j] = 0;
            } else {
                if(v1[i-1] == v2[j-1]) {
                    lcs[i][j] = 1 + lcs[i-1][j-1];
                } else {
                    lcs[i][j] = max(lcs[i-1][j], lcs[i][j-1]);
                }
            }
        }
    }
    cout << n + m - 2*lcs[n][m];
    return 0;
}