#include <iostream>
#include <vector>
#include <cstdio>

using namespace std;

int main() {
    int n, m;
    scanf("%d%d", &n, &m);
    vector<int> v1(n), v2(m);
    for(int i = 0; i < n; i++) {
        scanf("%d", &v1[i]);
    }
    for(int i = 0; i < m; i++) {
        scanf("%d", &v2[i]);
    }
    vector<vector<int> > lcs(n+1, vector<int>(m+1));
    for(int i = 0; i <= n; i++) {
        for(int j = 0; j <= m; j++) {
            if(i == 0 || j == 0) {
                lcs[i][j] = 0;
            } else {
                if(v1[i-1] == v2[j-1]) {
                    lcs[i][j] = 1 + lcs[i-1][j-1];
                } else {
                    lcs[i][j] = max(lcs[i-1][j], lcs[i][j-1]);
                }
            }
        }
    }
    printf("%d", n + m - 2*lcs[n][m]);
    return 0;
}