#include <iostream>
#include <vector>
#include <cstdio>
#include <map>

using namespace std;

int main() {
    int n, m;
    scanf("%d%d", &n, &m);
    vector<int> v1(n), v2(m);
    map<int, int> m1, m2;
    for(int i = 0; i < n; i++) {
        scanf("%d", &v1[i]);
        m1[v1[i]]++;
    }
    for(int i = 0; i < m; i++) {
        scanf("%d", &v2[i]);
        m2[v2[i]]++;
    }
    vector<int> V1, V2;
    for(int i = 0; i < n; i++) {
        if(m2[v1[i]] > 0) V1.push_back(v1[i]);
    }
    for(int i = 0; i < m; i++) {
        if(m1[v2[i]] > 0) V2.push_back(v2[i]);
    }
    int v1size = V1.size(), v2size = V2.size();
    vector<vector<int> > lcs(v1size+1, vector<int>(v2size+1));
    for(int i = 0; i <= v1size; i++) {
        for(int j = 0; j <= v2size; j++) {
            if(i == 0 || j == 0) {
                lcs[i][j] = 0;
            } else {
                if(V1[i-1] == V2[j-1]) {
                    lcs[i][j] = 1 + lcs[i-1][j-1];
                } else {
                    lcs[i][j] = max(lcs[i-1][j], lcs[i][j-1]);
                }
            }
        }
    }
    printf("%d", n + m - 2*lcs[v1size][v2size]);
    return 0;
}