#include <cstdio>
#include <math.h>

using namespace std;

double distance(int x1, int y1, int x2, int y2){
    return sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
}
int maxd(int x, int y, int x1, int y1, int g, int h){
    double a = distance(x,y,x1,y1);
    double b = distance(x,y,x1+g,y1);
    double c = distance(x,y,x1+g,y1+h);
    double d = distance(x,y,x1,y1+h);
    if (a>= b && a>= c && a>=d) return 1;
    if (b>= a && b>= c && b>=d) return 2;
    if (c>= b && c>= a && c>=d) return 3;
    if (d>= b && d>= c && d>=a) return 4;
    return -1;
}
int firstMDX(int maxd, int x, int a ){
    if (maxd == 1 || maxd == 4) return x;
    else return x + a;
}
int firstMDY(int maxd, int x, int a){
    if (maxd == 1 || maxd == 2) return x;
    else return x + a;
}
double getXUpd(int maxd, int x1, int a, double xt){
    double xn;
    if (maxd == 1 || maxd == 4){
        xn = (xt + x1)/2;
    }
    if (maxd == 2 || maxd == 3){
        xn = (xt + x1 + a)/2;
    }
    return xn;
}
double getYUpd(int maxd, int y1, int b, double yt){
    double yn;
    if (maxd == 1 || maxd == 2){
        yn = (yt + y1)/2;
    }
    if (maxd == 4 || maxd == 3){
        yn = (yt + y1 + b)/2;
    }
    return yn;
}
int main(){
    int n;
    scanf("%i", &n);
    int x1, y1, a, b;
    scanf("%i %i %i %i", &x1, &y1, &a, &b);
    int x[n] = {0};
    int y[n] = {0};
    for (int i = 0; i < n; i++){
        scanf("%i",&x[i]);
        scanf("%i",&y[i]);
    }
    double xt, yt;
    int maxD = maxd(x[0],y[0],x1,y1,a,b);
    xt = firstMDX(maxD, x1, a);
    yt = firstMDY(maxD, y1, b);
    for(int i = 1; i < n; i++){
        //printf("%i", getXUpd(x[i],y[i],x1,y1,a,b,1));
        maxD = maxd(x[i],y[i],x1,y1,a,b);
        xt += firstMDX(maxD, x1, a);
        yt += firstMDY(maxD, y1, b);
    }
    xt/=n;
    yt/=n;
    int z = 0;
    maxD = maxd(xt,yt,x1,y1,a,b);
    double blade = distance(xt,yt,firstMDX(maxD, x1,a),firstMDY(maxD, y1, b));
    for (int i = 0; i < n; i++){
        if (distance(xt,yt,x[i],y[i]) <= blade) z++;
    }
    printf("%d", z);
    return 0;
}