#include <iostream>
#include <algorithm>
#include <string>

using namespace std;

char numToChar(int num){
    switch(num){
    case 1:
        return '1';
    case 2:
        return '2';
    case 3:
        return '3';
    case 4:
        return '4';
    case 5:
        return '5';
    case 6:
        return '6';
    case 7:
        return '7';
    case 8:
        return '8';
    case 9:
        return '9';
    default: case 0:
        return '0';
    }
}

string numToString(long i){
    long t = i;
    string res = "";

    while(t != 0){
        res = numToChar(t % 10) + res;
        t /= 10;
    }

    return res;
}

string oddHalf(long n){
    string s1 = "", temp = "";

    for(long i = n - (n % 2 == 0 ? 1 : 0); i >= 1; i -= 2){
            s1.append((numToString(i) + " "));
    }

    temp = s1;
    reverse(temp.begin(), temp.end());
    s1 = s1 + "J";
/*
    cout << "Temp: " << temp << endl;
    cout << "S1: " << s1 << endl;
*/
    s1.append(temp);
    //cout << "|" << s1 << "|" << endl;

    return s1;
}

string evenHalf(long n){
    string s1 = "", temp = "";
    for(long i = n - (n % 2 == 1 ? 1 : 0); i >= 2; i -= 2){
            s1.append((numToString(i) + " "));
    }

    temp = s1;
    reverse(temp.begin(), temp.end());
    s1 = s1 + "J J";
/*
    cout << "Temp: " << temp << endl;
    cout << "S1: " << s1 << endl;
*/
    s1.append(temp);
    //cout << "|" << s1 << "|" << endl;

    return s1;
}

void createString(long n, long k){
    string e, o, j;

    e = evenHalf(n);
    o = oddHalf(n);

    j = "";
    for(int i = 0; i < k-3; i++){
        j += " J";
    }

    cout << e << j << " " << o;
}

int main(){
    ios_base::sync_with_stdio(false);

    long n, k;

    cin >> n >> k;

    if(k >= 3) createString(n, k);
    else {
        while(1) cout << " " << endl;
    }

    return 0;
}