#include <iostream>
#include <cstdio>
#include <cstring>

using namespace std;

int* input(int n){
    int *x = new int[n];
    for(int i = 0; i < n; i++)
        scanf("%d", x+i);
    return x;
}

void output(int n, int *x){
    for(int i = 0; i < n; i++)
        printf("%d ", x[i]);
}

int dp(int n, int *x, int m, int *y){
    int *t1 = new int[n], *t2 = new int[n];
    for(int i = 0; i < n; i++)
        t1[i] = 0;
    t2[0] = x[0] == y[0];
    for(int i = 1; i < n; i++)
        t2[i] = max(t2[i-1], (int)(x[i] == y[0]));
    for(int i = 1; i < m; i++){
        t2[0] = max(t1[0], (int)(x[0] == y[i]));
        for(int j = 1; j < n; j++){
            t2[j] = max(t1[j], t2[j-1]);
            if(x[j] == y[i])
                t2[j] = max(t2[j], t1[j-1]+1);
        }
        for(int j = 0; j < n; j++)
            t1[j] = t2[j];
    }
    int r = t2[n-1];
    delete[] t1;
    delete[] t2;
    return r;
}

int main(){
    int n, m, *a, *b;
    cin >> n >> m;
    a = input(n);
    b = input(m);
    cout << m + n - 2*dp(n, a, m, b);
    delete[] a;
    delete[] b;
    return 0;
}