#include <iostream>
#include <vector>

using namespace std;

struct cvor
{
    int siz=1;
    bool boring;
    vector<cvor> deca;
}cvorovi[100005];

bool solve(cvor c[], int a[], int n)
{
    bool sorted=true;
    for(int i=0;i<n-1;i++)
    {
        if(a[i]>a[i+1])sorted = false;
    }
    if(sorted)return true;
    if(c.boring)return false;
    if(c.deca.size()==1)return solve(c.deca.at(0), a, n);

    return false;
}

bool cboring(cvor* c)
{
    if(c->deca.size()>1)
    {
        c->boring = false;
        return false;
    }
    if(c->deca.size()==1)
    {
        c->boring = cboring(&c->deca.at(0));
        return c->boring;
    }
    c->boring = true;
    return c->boring;
}

int sizee(cvor* c)
{
    for(int i = 0;i<c->deca.size();i++)
    {
        c->siz += sizee(&c->deca.at(i));
    }
    return c->siz;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    cerr.tie(nullptr);

    int t,n,m,a[100005],l,d;
    bool tovi[10];
    cin >> t;
    for(int i = 0;i<t;i++)
    {
        cin >> n;
        for(int j = 0;j<n;j++)cin >> a[j];
        cin >> m;
        for(int j = 0;j<m-1;j++)
        {
            cin >> l >>d;
            cvorovi[l-1].deca.push_back(cvorovi[d-1]);
        }
        tovi[i]=solve(cvorovi[0],a,n);
        for(int i=0;i<100005;i++)
            cvorovi[i]= new cvor();
    }

    for(int i = 0;i<t;i++)if(tovi[i]==true)cout<<"DA"; else cout<<"NE";
    return 0;
}