#include <bits/stdc++.h>
#define endl '\n'
#define NL(x) " \n"[(x)]
#define PRINT(x) cerr<<#x<<' '<<x<<endl;
#define STIZE(x) cerr<<"STIZE"<<x<<endl;
#define all(x) begin(x),end(x)
#define sz(x) int((x).size())
#define lld long long
#define pii pair<int,int>
#define fi first
#define se second
#define pb push_back
#define INF 1000000000
using namespace std;
#define MAXN 100010
int siz[MAXN], dub[MAXN], a[MAXN], pos[MAXN];
vector<int> adj[MAXN];
int dfs(int cur, int prev, int dubb) {
    siz[cur] = 1;
    pos[cur] = 1;
    dub[cur] = dubb;
    for(auto x : adj[cur]) {
        if(!pos[x]) siz[cur] += dfs(x, cur, dubb+1);
    }
    return siz[cur];
}
int bit[MAXN];
void upd(int idx, int val) {
    while(idx < MAXN) {
        bit[idx] += val;
        idx += idx&-idx;
    }
}
int query(int idx) {
    int sum = 0;
    while(idx) {
        sum += bit[idx];
        idx -= idx&-idx;
    }
    return sum;
}
int vecih_levo(int idx) {
    return query(MAXN-1) - query(idx);
}

int main() {
    ios::sync_with_stdio(false);cin.tie(nullptr);
    int t; cin >> t;
    while(t--) {
        int n; cin >> n;
        fill(bit, bit+MAXN, 0);
        fill(pos, pos+MAXN, 0);
        fill(siz, siz+MAXN, 0);
        for(int i = 1; i <= n; i++) cin >> a[i];
        int m; cin >> m;
        for(int i = 1; i <= m; i++) if(sz(adj[i]) != 0) adj[i].clear();
        for(int i = 1; i <= m-1; i++) {
            int x, y; cin >> x >> y;
            adj[x].pb(y);
            adj[y].pb(x);
        }
        dfs(1, 1, -1);
        int najmanje_podstablo = INF, koje = 0;
        for(int x = 1; x <= m; x++) {
            if(siz[x]+dub[x] < najmanje_podstablo) najmanje_podstablo = siz[x]+dub[x], koje = x;
        }
        //while(a[n] == n) n--;
        /*if(n > m-1) {
            cout << "NE\n";
            continue;
        }*/
        int nema = 0;
        for(int i = 1; i <= n; i++) {
            if(m-1 - najmanje_podstablo - max(i - vecih_levo(a[i]) - najmanje_podstablo, 0) < n - (i + n - a[i])){
                //cout << i << ' ' << m-1 - najmanje_podstablo - max(i - vecih_levo(a[i]) - najmanje_podstablo, 0) << ' ' << n - (i + n - a[i]) << endl;
                nema = 1;
                //cout << i << endl;
                break;
            }
            upd(a[i], 1);
        }
        if(nema == 1) cout << "NE\n";
        else cout << "DA\n";
    }

    return 0;
}