#include <bits/stdc++.h>
using namespace std;

int t,n,m,in1,in2,realnodes,roditelj[100005],firstnode,veci[100005],maxi,stigao;
vector<int> p,kand;
vector<int> graf[100005];
bool activate;
stack<int> s;

void dfs_init(int node)
{
    if(activate)
    {
        realnodes++;
    }
    else if(graf[node].size()>2 || (node==1 && graf[node].size()>1))
    {
        activate=1;
        firstnode=node;
    }
    for(int i=0;i<graf[node].size();i++)
    {
        if(graf[node][i]!=roditelj[node])
        {
            roditelj[graf[node][i]]=node;
            dfs_init(graf[node][i]);
        }
    }
}

int dfs(int node)
{
    int zbir=0;
    for(int i=0;i<graf[node].size();i++)
    {
        if(graf[node][i]!=roditelj[node])
        {
            zbir+=dfs(graf[node][i]);
        }
    }
    return zbir+1;
}

bool comp(int a,int b)
{
    return b<a;
}

int main()
{
    ios::sync_with_stdio(false);
    cin>>t;
    for(;t>0;t--)
    {
        cin>>n;
        p.clear();
        p.resize(n);
        for(int i=0;i<n;i++)
        {
            cin>>p[i];
        }
        while(n>0 && p[n-1]==n)
        {
            p.pop_back();
            n--;
        }
        cin>>m;
        for(int i=1;i<=m;i++)
        {
            graf[i].clear();
        }
        for(int i=1;i<m;i++)
        {
            cin>>in1>>in2;
            graf[in1].push_back(in2);
            graf[in2].push_back(in1);
        }
        realnodes=0;
        activate=0;
        firstnode=0;
        dfs_init(1);
        if(n==0)
        {
            cout<<"DA\n";
            continue;
        }
        if(realnodes<n)
        {
            cout<<"NE\n";
            continue;
        }
        kand.clear();
        for(int i=0;i<graf[firstnode].size();i++)
        {
            if(graf[firstnode][i]!=roditelj[firstnode])
            {
                kand.push_back(dfs(graf[firstnode][i]));
            }
        }
        sort(kand.begin(),kand.end(),comp);
        /*for(int i=0;i<kand.size();i++)
        {
            cerr<<kand[i]<<" ";
        }*/
        while(!s.empty())
        {
            s.pop();
        }
        maxi=0;
        for(int i=n-1;i>=0;i--)
        {
            veci[p[i]]=0;
            while(!s.empty() && p[i]>s.top())
            {
                veci[p[i]]+=1+veci[s.top()];
                s.pop();
            }
            s.push(p[i]);
            maxi=max(maxi,veci[p[i]]);
        }
        for(stigao=0;stigao<kand.size();stigao++)
        {
            if(kand[stigao]>=maxi)
            {
                break;
            }
            maxi-=kand[stigao];
        }
        if(stigao==kand.size()-1)
        {
            cout<<"NE\n";
            continue;
        }
        else
        {
            cout<<"DA\n";
        }
    }
}