#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int LCS (vector< int > a, vector< int > b) {
    int dp[a.size() + 1][b.size() + 1];

    for (int i = 0; i <= a.size(); i++) {
        dp[i][0] = 0;
    }
    for (int i = 0; i <= b.size(); i++) {
        dp[0][i] = 0;
    }

    for (int i = 1; i <= a.size(); i++) {
        for (int j = 1; j <= b.size(); j++) {
            dp[i][j] = max(dp[i-1][j], dp[i][j-1]);
            if (a[i-1] == b[j-1]) {
                dp[i][j] = max(dp[i][j], dp[i-1][j-1] + 1);
            }
        }
    }
    return dp[a.size()][b.size()];
}

int main()
{
    int n, m;
    cin >> n >> m;
    vector< int > a (n), b(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> b[i];
    }
    cout << n + m - 2 * LCS(a, b);
    return 0;
}