#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int LCS (vector< int > a, vector< int > b) {
    int dp[b.size() + 1];

    for (int i = 0; i <= b.size(); i++) {
        dp[i] = 0;
    }

    for (int i = 1; i <= a.size(); i++) {
        for (int j = 1; j <= b.size(); j++) {
            dp[j] = max(dp[j], dp[j-1]);
            if (a[i-1] == b[j-1]) {
                dp[j] = max(dp[j], dp[j-1] + 1);
            }
        }
    }
    return dp[b.size()];
}

int main()
{
    cin.sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector< int > a (n), b(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> b[i];
    }
    cout << n + m - 2 * LCS(a, b);
    return 0;
}