#include <iostream>
#include <queue>

using namespace std;

void Print (queue<char> &q) {
    while (q.size()) {
        cout << q.front();
        q.pop();
    }
}

int main()
{
    bool inL = false;
    queue<char> l, r;
    cin.sync_with_stdio(false);
    cin.tie(0);
    cout.sync_with_stdio(false);
    cout.tie(0);

    int n, k, len = 0;
    cin >> n;
    char c;
    vector< int > d;
    for (int i = 0; i < n; i++) {
        cin >> k;
        if (k == 1) {
            len++;
            cin >> c;
            if (inL) {
                l.push(c);
                if (len % 2 == 0) {
                    r.push(l.front());
                    l.pop();
                }
            }
            else {
                r.push(c);
                if (len % 2 == 0) {
                    l.push(r.front());
                    r.pop();
                }
            }
        }
        else {
            inL = !inL;
        }
    }
    if (inL) {
        Print(r);
        Print(l);
    }
    else {
        Print(l);
        Print(r);
    }
}