//#HOUROFCODE
#include <bits/stdc++.h>
#define MAX_N 100005
#define eps 0.00001

using namespace std;

struct tacka{
	long long x, y;
	double tg;
	public:
		tacka(){
			x=y=0;
			tg=0;
			//gl=0;
		}
		tacka(int a, int b){
			x=a;
			y=b;
		}
		
} takm[MAX_N];

double dist(tacka a, tacka b){
	double dx=a.x-b.x;
	double dy=a.y-b.y;
	return sqrt(dx*dx+dy*dy);
}

double povrsina(tacka a, tacka b, tacka c){
	return ( (a.x-c.x) * (b.y-c.y) - (a.y-c.y) * (b.x-c.x) )/2.0;
}
long long sq_dist(tacka a, tacka b){
	return (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y);
}
int N;
long long X, Y, A, B;
int MIN_SOL;
bool cmp1y(tacka a, tacka b){
	return a.y<b.y;
}
bool cmp1x(tacka a, tacka b){
	return a.x<b.x;
}
bool cmpdonji(tacka a, tacka b){
	if(a.tg<0 && b.tg>0)return 1;
	if(a.tg>0 && b.tg<0)return 0;
	return a.tg>b.tg;
}
bool cmpgornji(tacka a, tacka b){
	if(a.tg>0 && b.tg<0)return 1;
	if(a.tg<0 && b.tg>0)return 0;
	return a.tg<b.tg;
}
void funkcija(){
	tacka GL=tacka(X, Y);
	tacka GD=tacka(X+A, Y);
	tacka DL=tacka(X, Y+B);
	tacka DD=tacka(X+A, Y+B);
	int broj_gsrednjih=0;
	int broj_gornjih=0;
	int broj_donjih=0;
	for(int i=0; i<N; ++i){
		if(takm[i].y>Y){
			broj_gornjih++;
		}
		if(takm[i].y==Y){
			broj_gsrednjih++;
		}
		if(takm[i].y<Y){
			broj_donjih++;
		}
		double sin=2*povrsina(GD, GL, takm[i])/( dist(takm[i], GL) * dist(takm[i], GD) );
		if(sin<0)sin=-sin;
		takm[i].tg=sin/sqrt(1-sin*sin);
		if(sq_dist(takm[i], GL)+sq_dist(takm[i], GD)<A*A)takm[i].tg=-takm[i].tg;
	}
	sort(takm, takm+N, cmp1y);
	tacka* donje=takm;
	tacka* gornje=takm+(broj_donjih+broj_gsrednjih);
	int d1=broj_donjih, d2=broj_gornjih;
	sort(donje, donje+d1, cmpdonji);
	sort(gornje, gornje+d2, cmpgornji);
	
	//Obradili smo sve sto treba, sad idemo u two-pointer pretragu po nizovima
	int indexg=0, indexd=0;
	while(indexd<d1 && donje[indexd].tg<0)indexd++;
	while(indexd<d1 && donje[indexd].tg> ((double) A)/((double) B) )indexd++;
	while(indexg<d2 && gornje[indexg].tg>0)indexg++;
	while(indexg<d2 && gornje[indexg].tg < -((double) A)/((double) B) )indexg++;
	if(MIN_SOL>d2-indexg+indexd)MIN_SOL=d2-indexg+indexd;
	while(indexg<d2){
		if( gornje[indexg].tg>-((double) A)/(2.0*B) ){
			break;
		}
		while(indexd<d1 && donje[indexd].tg>-gornje[indexg].tg){
			indexd++;
		}
		indexg++;
		if(MIN_SOL>d2-indexg+indexd)MIN_SOL=d2-indexg+indexd;
	}
	while(indexd<d1 && donje[indexd].tg > ((double) A)/(2.0*B))indexd++;
	if(MIN_SOL>d2-indexg+indexd)MIN_SOL=d2-indexg+indexd;
}
void zarotiraj(){
	for(int i=0; i<N; ++i){
		int ax=takm[i].x, ay=takm[i].y;
		takm[i].x=-ay;
		takm[i].y=ax;
	}
	int xp=-Y;
	int yp=X;
	X=xp;
	Y=yp;
	xp=A;
	A=B;
	B=xp;
	Y=Y+B;
}
int main(){
	ios::sync_with_stdio(false);
	cin>>N;
	cin>>X>>Y>>A>>B;
	for(int i=0; i<N; ++i)cin>>takm[i].x>>takm[i].y;
	MIN_SOL=N;
	funkcija();
	//cout<<MIN_SOL<<endl;
	zarotiraj();
	funkcija();
	//cout<<MIN_SOL<<endl;
	zarotiraj();
	funkcija();
	//cout<<MIN_SOL<<endl;
	zarotiraj();
	funkcija();
	cout<<MIN_SOL<<endl;
	return 0;               
}
/*
5
-12 8 20 12
9 1
-9 -9 
3 12
13 -4
-5 13

5
-4 2 8 4
0 4
0 -5
0 -6
0 3
0 -4
*/
/*printf("Donjih ima %d, a gornjih %d.\n", d1, d2);
	printf("Donje:");
	for(int i=0; i<d1; ++i){
		printf("donja[%d]=(%lld, %lld), tg=%lf\n", i, donje[i].x, donje[i].y, donje[i].tg);
	}
	for(int i=0; i<d2; ++i){
		printf("gornja[%d]=(%lld, %lld), tg=%lf\n", i, gornje[i].x, gornje[i].y, gornje[i].tg);
	}*/