#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define lb lower_bound
#define ub upper_bound
#define fr first
#define sc second
#define pii pair <int,int>
#define vi vector <int>
#define FOR(i,x,y) for (int i=x; i<=y; i++)

const int mod=int(1e9+7),MAXN=int(1e5+5);

struct clan
{
    int l,r,k;

    bool operator < (clan drugi) const
    {
        if (r!=drugi.r)
            return r<drugi.r;
        if (l!=drugi.l)
            return l<drugi.l;
        if (k!=drugi.k)
            return k<drugi.k;
        return 0;
    }
};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;
    while (t--)
    {
        int n,m,a[MAXN];
        clan b[MAXN];
        vi v[MAXN];
        cin >> n >> m;
        FOR(i,1,n)
        {
            cin >> a[i];
            v[i].resize(0);
        }
        FOR(i,1,m)
        {
            cin >> b[i].l;
            v[b[i].l].pb(i);
        }
        FOR(i,1,m)
            cin >> b[i].r;
        FOR(i,1,m)
            cin >> b[i].k;

        if (n>1000 || m>1000)
        {
            sort(b+1,b+m+1,cmp);

        int i=1,j=1;
        string rez="DA";

        while (i<=n && j<=m)
        {
            if (b[j].l<=i && b[j].r>=i)
            {
                int sr=min(a[i],b[j].k);
                a[i]-=sr;
                b[j].k-=sr;
                if (a[i]==0)
                    i++;
                if (b[j].k==0)
                    j++;
                continue;
            }
            if (b[j].l>i)
            {
                if (a[i]==0)
                    i++;
                else
                {
                    rez="NE";
                    break;
                }
            }
            if (b[j].r<i)
                j++;
        }

        if (i<=n)
            rez="NE";
        cout << rez << '\n';
        }
     continue;
    }

        set <clan> s;
        s.clear();

        string rez="DA\n";

        FOR(i,1,n)
        {
            for (auto j:v[i])
                s.insert(b[j]);

            while (a[i]>0 && !s.empty())
            {
                clan pom=*s.begin();
                s.erase(s.begin());
                if (pom.r<i)
                    continue;
                int sr=min(a[i],pom.k);
                a[i]-=sr;
                pom.k-=sr;
                if (pom.k>0 && pom.r>i)
                    s.insert(pom);
            }

            if (a[i]>0)
            {
                rez="NE\n";
                break;
            }
        }

        cout << rez;
    }

    return 0;
}