#include <iostream>
#include <vector>

using namespace std;

int par[100005], b[100005], a[100005], n, m, t, u, v, gran;
bool taken[100005], done;
vector<int> g[100005];

void dfs(int x, int p) {
    par[x] = p;
    for (int i = 0; i < g[x].size(); i++)
        if (g[x][i] != p) dfs(g[x][i], x);
}

bool checkrek(int x, int val, int ind) {
    if (b[x] != 0) {
        if (a[b[x]] > val) return false;
        if (b[x] > ind) return false;
    }
    int res = true;
    for (int i = 0; i < g[x].size(); i++) {
        if (g[x][i] != par[x]) res &= checkrek(g[x][i], b[x] != 0 ? a[b[x]] : val, b[x] != 0 ? b[x] : ind);
    }
    return res;
}

bool check() {
    int root;
    for (int i = 1; i <= gran; i++)
        if (!taken[i]) return false;
    for (int i = 1; i <= m; i++)
        if (par[i] == 0) root = i;
    return checkrek(root, 1e9, 1e9);
}

void bt(int x) {
    if (x > m) {
        if (check()) {
            done = true;
            for (int i = 1; i <= m; i++) cerr << par[i] << " ";
            cerr << endl;
            for (int i = 1; i <= m; i++) cerr << b[i] << " ";
            cerr << endl;
            return;
        }
    } else {
        for (int i = 0; i <= gran; i++) {
            if (i == 0 || !taken[i]) {
                b[x] = i;
                taken[i] = true;
                bt(x+1);
                taken[i] = false;
                if (done) return;
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> t;
    while (t--) {
        done = false;
        cin >> n;
        for (int i = 1; i <= n; i++) cin >> a[i];
        for (int i = n; i >= 1; i--) {
            if (a[i] != i) {
                gran = i;
                break;
            }
        }
        cerr << "GRAN " << gran << endl;
        cin >> m;
        for (int i = 0; i <= m; i++) g[i].clear();
        for (int i = 0; i < m-1; i++) {
            cin >> u >> v;
            g[u].push_back(v);
            g[v].push_back(u);
        }
        //for (int i = 1; i <= m; i++) {
            //dfs(i, 0);
            dfs(1, 0);
            bt(1);
            if (done) {
                cout << "DA\n";
                //break;
            }
        //}
        if (!done) cout << "NE\n";
    }
    return 0;
}

/*

2
8
5 3 4 2 7 8 1 6
9
1 2
1 3
2 4
2 5
2 6
3 7
7 8
7 9
8
7 8 2 3 5 6 1 4
9
1 2
1 3
2 4
2 5
2 6
3 7
7 8
7 9
8
6 1 8 7 2 4 3 5
9
1 2
1 3
2 4
2 5
2 6
3 7
7 8
7 9
8
4 1 6 5 3 2 8 7
9
1 2
1 3
2 4
2 5
2 6
3 7
7 8
7 9


*/